
function transformMenuToRoute(menu, depth = 0) {
    // 如果没有菜单数据，返回 null
    if (!menu) return null;

    // 根级菜单转换
    const route = {
        path: menu.menuId,
        component: depth === 0 ? layout : undefined,
        meta: {
            showInMenu: true,
            title: menu.name,
            icon: menu.icon || 'el-icon-s-home'
        },
        children: []
    };

    // 递归处理子菜单
    if (menu.list && menu.list.length > 0) {
        route.children = menu.list
            .map(childMenu => {
                const childRoute = {
                    path: childMenu.url,
                    name: childMenu.url,
                    component: httpVueLoader(`./src/views/${childMenu.url.replace(/^\/views\//, '')}.vue`),
                    meta: {
                        title: childMenu.name,
                        icon: childMenu.icon || 'icon',
                        noCache: true,
                        showInMenu: true
                    }
                };

                // 如果子菜单还有下一级菜单，继续递归
                if (childMenu.list && childMenu.list.length > 0) {
                    const nestedRoute = transformMenuToRoute(childMenu, depth + 1);
                    if (nestedRoute) {
                        childRoute.children = [nestedRoute];
                    }
                }

                return childRoute;
            })
            .filter(route => route); // 过滤掉 null 或 undefined 的路由
    }

    return route;
}






var tokenName = 'token'
var store = new Vuex.Store({
    state: {
        //初始值设置，组件要获取的基本都是这里预先设置好的值
        token: Cookies.get(tokenName),
        roles: [],
        common:{
            paginationLayout: "total, sizes, prev, pager, next, jumper"
        }
    },
    mutations: {
        SET_TOKEN: (state, token) => {
            state.token = token
        },
        SET_ROLES: (state, roles) => {
            state.roles = roles
        }
    },
    actions: {
        //负责处理异步操作，再调用mutations里面的方法，异步操作如果写在mutations数据可能会丢失
        // this.$store.dispatch('aEdit','xxxxx')
        login({ commit }, userInfo) {

            const { username, password } = userInfo
            console.log(  username, password )

            if( username == '' || password == '' ){
                return  ELEMENT.Message.error('不能为空');
            }



            if( username != 'admin' || password != 'admin' ){
                return  ELEMENT.Message.error('密码或账号错误');
            }


            return new Promise((resolve, reject) => {
                console.log('userInfo1')
                // login({ username: username.trim(), password: password }).then(response => {
                //     const { data } = response
                //     commit('SET_TOKEN', data.token)
                   commit('SET_TOKEN', 1111111)
                // Cookies.set('token', data.token)
                   Cookies.set(tokenName, 1111111)
                   resolve()
                // }).catch(error => {
                //     console.log(error)
                //     reject(error)
                // })
            })
        },

        // get user info
        getInfo({ commit, state }) {
            return new Promise((resolve, reject) => {
                // getInfo(state.token).then(response => {
                //     const { data } = response
                //
                //     if (!data) {
                //         reject('再次登录')
                //     }

                // var menuList=   [
                //     {
                //         "menuId": "103",
                //         "parentId": "0",
                //         "parentName": null,
                //         "name": "建表模板",
                //         "url": "",
                //         "perms": null,
                //         "type": 0,
                //         "icon": "menu",
                //         "orderNum": 13,
                //         "appId": "2",
                //         "open": null,
                //         "list": [
                //             {
                //                 "menuId": "104",
                //                 "parentId": "103",
                //                 "parentName": null,
                //                 "name": "建表模板列表",
                //                 "url": "/views/atabletemplate",
                //                 "perms": null,
                //                 "type": 1,
                //                 "icon": "menu",
                //                 "orderNum": 13,
                //                 "appId": "2",
                //                 "open": null,
                //                 "list": null
                //             }
                //         ]
                //     }
                // ]

                // const transformedRoutes = menuList.map(menu => transformMenuToRoute(menu));


                var data = {
                    roles:['admin'],
                    // menus:transformedRoutes
                    menus:[   //动态路由
                        {
                            path: '/icon',
                            component: layout ,
                            meta: {
                                showInMenu: true,
                                title: '仪表盘',
                                icon: 'el-icon-s-home'
                            },
                            children: [
                                {
                                    path: 'icon',
                                    name: 'icon',
                                    component: httpVueLoader('./src/views/icons/index.vue'),
                                    meta: { title: 'icon页面', icon: 'icon', noCache: true }
                                }
                            ]
                        },
                        {
                            path: '/a',
                            component: layout ,
                            meta: {
                                showInMenu: true,
                                icon: 'el-icon-s-home',
                                title: '父a页面'
                            },
                            children: [
                                {
                                    path: 'a',
                                    name: 'a',
                                    component: httpVueLoader('./src/views/a/index.vue'),
                                    meta: { title: '子a页面1', icon: 'icon', noCache: true,showInMenu: true }
                                },
                                {
                                    path: 'a1',
                                    name: 'a1',
                                    component: httpVueLoader('./src/views/tprocessdetail.vue'),
                                    meta: { title: '子a页面2', icon: 'icon', noCache: true,showInMenu: true }
                                }
                            ]
                        },
                        {
                            path: '/test',
                            component: layout ,
                            children: [
                                {
                                    path: 'test',
                                    name: 'test',
                                    component: httpVueLoader('./src/views/test.vue'),
                                    meta: { title: 'test页面', icon: 'icon', noCache: true }
                                }
                            ]
                        },
                        {
                            path: '/tprocessdetail',
                            component: layout ,
                            children: [
                                {
                                    path: 'tprocessdetail',
                                    name:'tprocessdetail',
                                    component: httpVueLoader('./src/views/tprocessdetail.vue'),
                                    meta: { title: 'tprocessdetail母版页', icon: 'icon', noCache: true }
                                }
                            ]

                        },
                        {
                            path: '/tprocessdetail-add-or-update',
                            component: layout ,
                            meta: {
                                title: 'tprocessdetail主页',
                                showInMenu: true,
                                icon: 'el-icon-s-home'
                            },
                            children: [
                                {
                                    path: '/tprocessdetail-add-or-update/tprocessdetail-add-or-update',
                                    name:'tprocessdetail-add-or-update',
                                    component: httpVueLoader('./src/views/tprocessdetail-add-or-update.vue'),
                                    meta: { title: 'tprocessdetail母版页', icon: 'icon', noCache: true ,showInMenu: true},
                                    children: []
                                },
                                {
                                    path: '/tprocessdetail-add-or-update/a',
                                    name:'a',
                                    component: httpVueLoader('./src/views/test.vue'),
                                    meta: { title: 'tprocessdetail母版页', icon: 'icon', noCache: true ,showInMenu: true},
                                    children: []
                                }
                            ]

                        },






                    ]
                }
                const { roles, name, avatar, introduction } = data

                // roles must be a non-empty array
                if (!roles || roles.length <= 0) {
                    reject('无登录角色')
                }

                commit('SET_ROLES', roles)

                setTimeout(()=>{  //模拟接口延迟
                    resolve(data)
                })

                // }).catch(error => {
                //     reject(error)
                // })
            })
        },



        logout({ commit, state, dispatch }) {
            return new Promise((resolve, reject) => {
                // logout(state.token).then(() => {
                commit('SET_TOKEN', '')
                commit('SET_ROLES', [])
                Cookies.remove(tokenName)


                const createRouter = () => new VueRouter({
                    // mode: 'history', // require service support
                    scrollBehavior: () => ({ y: 0 }),
                    routes: constantRoutes
                })
                const router = createRouter()
                const newRouter = createRouter()
                router.matcher = newRouter.matcher // reset router

                resolve()
                // }).catch(error => {
                //     reject(error)
                // })
            })
        },



        // remove token
        resetToken({ commit }) {
            return new Promise(resolve => {
                commit('SET_TOKEN', '')
                commit('SET_ROLES', [])
                Cookies.remove(tokenName)
                resolve()
            })
        }

    },
    getters : {
        token: state => state.token,
        roles: state => state.roles,
    }
})
